# array of arrays but with a given number of arrays (M) and given total length (N)

struct FlatMatrix{T,N,M}
    values::NTuple{N,T}
    indices::NTuple{M,Int}

    function FlatMatrix(v::Vector{Vector{T}}) where {T}
        M = length(v)
        N = sum(length.(v))

        values = NTuple{N,T}(vcat(v...))
        indices = ntuple(i -> sum(length.(v[1:i-1])), M)

        return new{Int,N,M}(values, indices)
    end
end

function Base.getindex(m::FlatMatrix{T,N,M}, x::Int, y::Int) where {T,N,M}
    x <= M || throw(InvalidInputError("invalid indices ($x, $y) for flat matrix $m"))
    (x > 0 && y > 0) || throw(InvalidInputError("invalid indices ($x, $y) for flat matrix $m"))
    x == M ? m.indices[x] + y <= N : m.indices[x] + y <= m.indices[x+1] || throw(InvalidInputError("invalid indices ($x, $y) for flat matrix $m"))
    return m.values[m.indices[x]+y]
end
